function Matrix=SimSonic3DReadRcv3D(FileName)

% SIMSONIC3DREADRCV3D reads .rcv3D file (receiving array)
%
%   ARRAY = SIMSONIC3DREADRCV3D(FILENAME) reads FILENAME into a
%   structure ARRAY
%
%   The size of ARRAY.SIGNALS must be (NbTimePoints,NbEltsJ,NbEltsK)
%
%   SimSonic3D toolbox
%   Author: Emmanuel Bossy
%   Date: 2012/11/19

fid = -1;
fid=fopen(FileName,'rb');

if fid~=-1
    Normal=char(fread(fid,1,'char'));        
    NbJ = fread(fid,1,'int');
    NbK = fread(fid,1,'int');
    XMat = fread(fid,1,'int');
    YMat = fread(fid,1,'int');
    ZMat = fread(fid,1,'int');
    WidthJ = fread(fid,1,'int');
    WidthK = fread(fid,1,'int');
    PitchJ = fread(fid,1,'int');
    PitchK = fread(fid,1,'int');
    H = fread(fid,1,'double');
    DurationPt=fread(fid,1,'int');
    DeltaT=fread(fid,1,'double');
    Signals=fread(fid,'double');
    fclose(fid);
    %Signals=reshape(Signals,DurationPt,NbJ*NbK);
    
    Signals=reshape(Signals,DurationPt,NbJ,NbK);
    
Matrix=struct(...
   'Normal',Normal,...
   'NbEltsJ',NbJ,...
   'NbEltsK',NbK,...
   'X1_start',XMat,...
   'X2_start',YMat,...
   'X3_start',ZMat,...
   'WidthJ',WidthJ,...
   'WidthK',WidthK,...
   'PitchJ',PitchJ,...
   'PitchK',PitchK,...
   'Spatial_step_mm',H,...
   'Temporal_step_us',DeltaT,...
   'NbTimePoints',DurationPt,....
   'Signals',Signals);

else
    disp('File not found...');
    Matrice=[];
end
